"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationQueue = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
class NotificationQueue extends rxjs_1.Observable {
    constructor(notifier) {
        super((observer) => {
            const index = this._count++;
            const subscription = this._notifications
                .pipe(operators_1.first((value) => value === index))
                .subscribe(observer);
            this._indices.next(index);
            return subscription;
        });
        this._count = 0;
        this._indices = new rxjs_1.Subject();
        this._notifications = rxjs_1.zip(notifier, this._indices).pipe(operators_1.map(([, index]) => index), operators_1.publish());
    }
    connect() {
        return this._notifications.connect();
    }
}
exports.NotificationQueue = NotificationQueue;
//# sourceMappingURL=NotificationQueue.js.map