"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.combineLatestHigherOrder = exports.combineLatestHigherOrderArray = void 0;
const rxjs_1 = require("rxjs");
function combine(sources, observer) {
    if (sources.every(({ nexted }) => nexted)) {
        observer.next(sources.map(({ value }) => value));
    }
}
function combineLatestHigherOrderArray() {
    return (higherOrder) => new rxjs_1.Observable((observer) => {
        let lasts = [];
        let nexts = [];
        let higherOrderCompleted = false;
        const higherOrderSubscription = new rxjs_1.Subscription();
        higherOrderSubscription.add(higherOrder.subscribe((observables) => {
            const subscribes = [];
            nexts = observables.map((observable) => {
                const index = lasts.findIndex((last) => last.observable === observable);
                if (index !== -1) {
                    const next = lasts[index];
                    lasts.splice(index, 1);
                    return next;
                }
                const next = {
                    completed: false,
                    nexted: false,
                    observable,
                };
                subscribes.push(() => {
                    if (higherOrderSubscription.closed) {
                        return;
                    }
                    next.subscription = next.observable.subscribe((value) => {
                        next.nexted = true;
                        next.value = value;
                        combine(nexts, observer);
                    }, (error) => observer.error(error), () => {
                        next.completed = true;
                        if (higherOrderCompleted &&
                            nexts.every(({ completed }) => completed)) {
                            observer.complete();
                        }
                    });
                    higherOrderSubscription.add(next.subscription);
                });
                return next;
            });
            lasts.forEach(({ subscription }) => {
                if (subscription) {
                    subscription.unsubscribe();
                }
            });
            lasts = nexts;
            combine(nexts, observer);
            subscribes.forEach((subscribe) => subscribe());
        }, (error) => observer.error(error), () => {
            if (lasts.every(({ completed }) => completed)) {
                observer.complete();
            }
            higherOrderCompleted = true;
        }));
        return higherOrderSubscription;
    });
}
exports.combineLatestHigherOrderArray = combineLatestHigherOrderArray;
exports.combineLatestHigherOrder = combineLatestHigherOrderArray;
//# sourceMappingURL=combineLatestHigherOrderArray.js.map