"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forkJoinObject = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const util_1 = require("../util");
const forkJoinArray_1 = require("./forkJoinArray");
function forkJoinObject(instance) {
    const entries = Object.entries(instance);
    const observables = entries.map(([, value]) => util_1.isObservable(value) ? value : rxjs_1.of(value));
    return forkJoinArray_1.forkJoinArray(observables).pipe(operators_1.map((values) => values.reduce((acc, value, index) => {
        acc[entries[index][0]] = value;
        return acc;
    }, {})));
}
exports.forkJoinObject = forkJoinObject;
//# sourceMappingURL=forkJoinObject.js.map