"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.progress = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function progress(observables, resultSelector, sourceSelector) {
    return new rxjs_1.Observable((subscriber) => {
        let finalized = 0;
        let nexted = 0;
        const total = observables.length;
        const state = new rxjs_1.Subject();
        const shared = new rxjs_1.Subject();
        const source = (sourceSelector || rxjs_1.forkJoin)(observables.map((o) => o.pipe(operators_1.tap(() => state.next({
            finalized,
            nexted: ++nexted,
            total,
        })), operators_1.finalize(() => {
            state.next({
                finalized: ++finalized,
                nexted,
                total,
            });
            if (finalized === total) {
                state.complete();
            }
        }))));
        const result = resultSelector(state, shared);
        const subscription = result.subscribe(subscriber);
        subscription.add(source.subscribe(shared));
        return subscription;
    });
}
exports.progress = progress;
//# sourceMappingURL=progress.js.map