"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.separate = void 0;
const operators_1 = require("rxjs/operators");
function not(...predicates) {
    return (value) => predicates.every((predicate) => !predicate(value));
}
function separate(source, ...predicates) {
    const shared = source.pipe(operators_1.share());
    return [
        ...predicates.map((predicate) => shared.pipe(operators_1.filter(predicate))),
        shared.pipe(operators_1.filter(not(...predicates))),
    ];
}
exports.separate = separate;
//# sourceMappingURL=separate.js.map