"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zipObject = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const util_1 = require("../util");
const zipArray_1 = require("./zipArray");
function zipObject(instance) {
    const entries = Object.entries(instance);
    const observables = entries.map(([, value]) => util_1.isObservable(value) ? value : rxjs_1.of(value));
    return zipArray_1.zipArray(observables).pipe(operators_1.map((values) => values.reduce((acc, value, index) => {
        acc[entries[index][0]] = value;
        return acc;
    }, {})));
}
exports.zipObject = zipObject;
//# sourceMappingURL=zipObject.js.map