"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zipPadded = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function zipPadded(sources, padValue) {
    return new rxjs_1.Observable((observer) => {
        const publishedSources = sources.map((source) => source.pipe(operators_1.publish()));
        const indices = rxjs_1.merge(...publishedSources.map((source) => source.pipe(operators_1.map((unused, index) => index)))).pipe(operators_1.scan((max, index) => Math.max(max, index), 0), operators_1.distinctUntilChanged(), operators_1.publish());
        const subscription = rxjs_1.zip(...publishedSources.map((source) => rxjs_1.concat(source, indices.pipe(operators_1.mapTo(padValue))))).subscribe(observer);
        subscription.add(indices.connect());
        publishedSources.forEach((source) => subscription.add(source.connect()));
        return subscription;
    });
}
exports.zipPadded = zipPadded;
//# sourceMappingURL=zipPadded.js.map