"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.auditMap = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function auditMap(project) {
    return (source) => {
        let pending = false;
        let queued = undefined;
        return source.pipe(operators_1.mergeMap((value, index) => {
            if (pending) {
                queued = [value, index];
                return rxjs_1.EMPTY;
            }
            pending = true;
            return rxjs_1.from(project(value, index)).pipe(operators_1.concat(rxjs_1.defer(() => {
                if (!queued) {
                    return rxjs_1.EMPTY;
                }
                const projected = project(...queued);
                queued = undefined;
                return rxjs_1.from(projected);
            })), operators_1.last(), operators_1.tap({
                complete: () => (pending = false),
            }));
        }));
    };
}
exports.auditMap = auditMap;
//# sourceMappingURL=auditMap.js.map