"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.debounceTimeWithinReason = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function debounceTimeWithinReason(debounceDuration, reasonableDuration, scheduler) {
    return (source) => source.pipe(operators_1.publish((sharedSource) => new rxjs_1.Observable((observer) => {
        let reasonableTimer;
        const debounced = sharedSource.pipe(operators_1.debounce(() => rxjs_1.merge(rxjs_1.timer(debounceDuration, scheduler), reasonableTimer)));
        reasonableTimer = debounced.pipe(operators_1.mapTo(undefined), operators_1.startWith(undefined), operators_1.switchMap(() => rxjs_1.timer(reasonableDuration, scheduler)), operators_1.publish());
        const subscription = new rxjs_1.Subscription();
        subscription.add(reasonableTimer.connect());
        subscription.add(debounced.subscribe(observer));
        return subscription;
    })));
}
exports.debounceTimeWithinReason = debounceTimeWithinReason;
//# sourceMappingURL=debounceTimeWithinReason.js.map