"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.dispose = void 0;
function dispose(callback) {
    return (source) => source.lift(new DisposeOperator(callback));
}
exports.dispose = dispose;
class DisposeOperator {
    constructor(callback) {
        this.callback = callback;
    }
    call(subscriber, source) {
        const subscription = source.subscribe(subscriber);
        subscription.add(this.callback);
        return subscription;
    }
}
//# sourceMappingURL=dispose.js.map