"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.finalizeWithKind = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function finalizeWithKind(callback) {
    return (source) => rxjs_1.defer(() => {
        let kind = "U";
        return source.pipe(operators_1.tap({
            complete: () => (kind = "C"),
            error: () => (kind = "E"),
        }), operators_1.finalize(() => callback(kind)));
    });
}
exports.finalizeWithKind = finalizeWithKind;
//# sourceMappingURL=finalizeWithKind.js.map