"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.finalize = exports.inexorably = void 0;
const rxjs_1 = require("rxjs");
function inexorably(callback) {
    return (source) => source.lift(new InexorablyOperator(callback));
}
exports.inexorably = inexorably;
exports.finalize = inexorably;
class InexorablyOperator {
    constructor(callback) {
        this.callback = callback;
    }
    call(subscriber, source) {
        return source.subscribe(new InexorablySubscriber(subscriber, this.callback));
    }
}
class InexorablySubscriber extends rxjs_1.Subscriber {
    constructor(destination, callback) {
        super(destination);
        this.add(new rxjs_1.Subscription(() => callback(this.notification)));
    }
    complete() {
        this.notification = new rxjs_1.Notification("C");
        super.complete();
    }
    error(error) {
        this.notification = new rxjs_1.Notification("E", undefined, error);
        super.error(error);
    }
}
//# sourceMappingURL=inexorably.js.map