"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.materializeTap = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function materializeTap(next) {
    return (source) => source.pipe(operators_1.tap({
        complete: () => next(new rxjs_1.Notification("C")),
        error: (error) => next(new rxjs_1.Notification("E", undefined, error)),
        next: (value) => next(new rxjs_1.Notification("N", value)),
    }));
}
exports.materializeTap = materializeTap;
//# sourceMappingURL=materializeTap.js.map