"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multicastWithKind = void 0;
const operators_1 = require("rxjs/operators");
const finalizeWithKind_1 = require("./finalizeWithKind");
function multicastWithKind(factory, selector) {
    return (source) => {
        let kind = undefined;
        let subject = undefined;
        return source.pipe(finalizeWithKind_1.finalizeWithKind((k) => (kind = k)), operators_1.multicast(() => {
            subject = factory(kind, subject);
            kind = undefined;
            return subject;
        }, selector));
    };
}
exports.multicastWithKind = multicastWithKind;
//# sourceMappingURL=multicastWithKind.js.map