"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.prioritize = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function prioritize(selector) {
    return (source) => new rxjs_1.Observable((observer) => {
        const published = operators_1.publish()(source);
        const subjects = [];
        const subscription = new rxjs_1.Subscription();
        const length = Math.max(selector.length, 2);
        for (let i = 0; i < length; ++i) {
            const subject = new rxjs_1.Subject();
            subjects.push(subject);
            subscription.add(published.subscribe(subject));
        }
        const [first, second, ...rest] = subjects;
        subscription.add(selector(first, second, ...rest).subscribe(observer));
        subscription.add(published.connect());
        return subscription;
    });
}
exports.prioritize = prioritize;
//# sourceMappingURL=prioritize.js.map