"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.refCountOn = void 0;
const rxjs_1 = require("rxjs");
function refCountOn(scheduler) {
    return (source) => {
        const connectable = source;
        let count = 0;
        let subscription = null;
        return rxjs_1.using(() => {
            ++count;
            scheduler.schedule(() => {
                if (!subscription && count > 0) {
                    subscription = connectable.connect();
                }
            });
            return {
                unsubscribe: () => {
                    --count;
                    scheduler.schedule(() => {
                        if (subscription && count === 0) {
                            subscription.unsubscribe();
                            subscription = null;
                        }
                    });
                },
            };
        }, () => source);
    };
}
exports.refCountOn = refCountOn;
//# sourceMappingURL=refCountOn.js.map