"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipSync = void 0;
const rxjs_1 = require("rxjs");
function skipSync() {
    return (source) => new rxjs_1.Observable((subscriber) => {
        let subscribed = false;
        const subscription = source.subscribe((value) => subscribed && subscriber.next(value), subscriber.error.bind(subscriber), subscriber.complete.bind(subscriber));
        subscribed = true;
        return subscription;
    });
}
exports.skipSync = skipSync;
//# sourceMappingURL=skipSync.js.map