"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.startWithTimeout = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function startWithTimeout(value, duration, scheduler) {
    if (duration === 0 && !scheduler) {
        return (source) => new rxjs_1.Observable((subscriber) => {
            let nexted = false;
            const subscription = source.subscribe((value) => {
                nexted = true;
                subscriber.next(value);
            }, subscriber.error.bind(subscriber), subscriber.complete.bind(subscriber));
            if (!nexted) {
                subscriber.next(value);
            }
            return subscription;
        });
    }
    return (source) => source.pipe(operators_1.publish((published) => rxjs_1.race(published, rxjs_1.concat(rxjs_1.timer(duration, scheduler).pipe(operators_1.mapTo(value)), published))));
}
exports.startWithTimeout = startWithTimeout;
//# sourceMappingURL=startWithTimeout.js.map