"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tapWithIndex = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function tapWithIndex(nextOrObserver, error, complete) {
    return (source) => rxjs_1.defer(() => {
        let index = -1;
        let context;
        let handleNext;
        let handleError;
        let handleComplete;
        if (nextOrObserver && typeof nextOrObserver !== "function") {
            context = nextOrObserver;
            handleNext = nextOrObserver.next || rxjs_1.noop;
            handleError = nextOrObserver.error || rxjs_1.noop;
            handleComplete = nextOrObserver.complete || rxjs_1.noop;
        }
        else {
            context = undefined;
            handleNext = nextOrObserver || rxjs_1.noop;
            handleError = error || rxjs_1.noop;
            handleComplete = complete || rxjs_1.noop;
        }
        return source.pipe(operators_1.tap((value) => handleNext.call(context, [value, ++index]), (error) => handleError.call(context, error), () => handleComplete.call(context)));
    });
}
exports.tapWithIndex = tapWithIndex;
//# sourceMappingURL=tapWithIndex.js.map