"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unsubscribeOn = void 0;
const rxjs_1 = require("rxjs");
function unsubscribeOn(scheduler, delay = 0) {
    return (source) => source.lift(new UnsubscribeOnOperator(scheduler, delay));
}
exports.unsubscribeOn = unsubscribeOn;
class UnsubscribeOnOperator {
    constructor(scheduler, delay) {
        this.scheduler = scheduler;
        this.delay = delay;
    }
    call(subscriber, source) {
        return source.subscribe(new UnsubscribeOnSubscriber(subscriber, this.scheduler, this.delay));
    }
}
class UnsubscribeOnSubscriber extends rxjs_1.Subscriber {
    constructor(destination, scheduler, delay) {
        super(destination);
        this.scheduler = scheduler;
        this.delay = delay;
    }
    unsubscribe() {
        const { delay, scheduler } = this;
        scheduler.schedule(() => super.unsubscribe(), delay);
    }
}
//# sourceMappingURL=unsubscribeOn.js.map