"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withLatestFromWhen = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function withLatestFromWhen(...args) {
    const flushSelector = args.pop();
    const observables = args;
    return (source) => new rxjs_1.Observable((subscriber) => {
        const publishedSource = operators_1.publish()(source);
        const publishedObservables = observables.map((o) => rxjs_1.from(o).pipe(operators_1.publish()));
        const subscription = new rxjs_1.Subscription();
        subscription.add(flushSelector()
            .pipe(operators_1.startWith(undefined), operators_1.switchMap(() => publishedSource.pipe(operators_1.withLatestFrom(...publishedObservables))))
            .subscribe(subscriber));
        publishedObservables.forEach((p) => subscription.add(p.connect()));
        subscription.add(publishedSource.connect());
        return subscription;
    });
}
exports.withLatestFromWhen = withLatestFromWhen;
//# sourceMappingURL=withLatestFromWhen.js.map