import { of } from "rxjs";
import { map } from "rxjs/operators";
import { isObservable } from "../util";
import { forkJoinArray } from "./forkJoinArray";
export function forkJoinObject(instance) {
    const entries = Object.entries(instance);
    const observables = entries.map(([, value]) => isObservable(value) ? value : of(value));
    return forkJoinArray(observables).pipe(map((values) => values.reduce((acc, value, index) => {
        acc[entries[index][0]] = value;
        return acc;
    }, {})));
}
//# sourceMappingURL=forkJoinObject.js.map