import { forkJoin, Observable, Subject } from "rxjs";
import { finalize, tap } from "rxjs/operators";
export function progress(observables, resultSelector, sourceSelector) {
    return new Observable((subscriber) => {
        let finalized = 0;
        let nexted = 0;
        const total = observables.length;
        const state = new Subject();
        const shared = new Subject();
        const source = (sourceSelector || forkJoin)(observables.map((o) => o.pipe(tap(() => state.next({
            finalized,
            nexted: ++nexted,
            total,
        })), finalize(() => {
            state.next({
                finalized: ++finalized,
                nexted,
                total,
            });
            if (finalized === total) {
                state.complete();
            }
        }))));
        const result = resultSelector(state, shared);
        const subscription = result.subscribe(subscriber);
        subscription.add(source.subscribe(shared));
        return subscription;
    });
}
//# sourceMappingURL=progress.js.map