import { filter, share } from "rxjs/operators";
function not(...predicates) {
    return (value) => predicates.every((predicate) => !predicate(value));
}
export function separate(source, ...predicates) {
    const shared = source.pipe(share());
    return [
        ...predicates.map((predicate) => shared.pipe(filter(predicate))),
        shared.pipe(filter(not(...predicates))),
    ];
}
//# sourceMappingURL=separate.js.map